package com.bomostory.sceneeditmodule

import android.content.DialogInterface
import android.graphics.Paint
import android.os.Bundle
import android.support.v4.app.DialogFragment
import android.support.v4.content.ContextCompat
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.view.Window
import com.bomostory.sceneeditmodule.basicdata.Actor
import com.example.tfat.myapplication.R
import kotlinx.android.synthetic.main.dialogfragment_edit_text.view.*

class EditTextDialog : DialogFragment() {
    var onSetDialogFinish: OnSetDialogFinish? = null
    lateinit var dialogueActor: Actor

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.dialogfragment_edit_text, container).apply {
            dialog.requestWindowFeature(Window.FEATURE_NO_TITLE)
            btn_edit_dialog_done.setOnClickListener {
                onSetDialogFinish?.onSetDialogText(dialogueActor, etv_text.text.toString())
            }
            iv_edit_text_red.setOnClickListener {
                iv_edit_text_red.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
                iv_edit_text_yellow.background = null
                iv_edit_text_blue.background = null
                iv_edit_text_green.background = null
                iv_edit_text_black.background = null
                dialogueActor?.textColor = "#d0021b"
            }
            iv_edit_text_yellow.setOnClickListener {
                iv_edit_text_red.background = null
                iv_edit_text_yellow.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
                iv_edit_text_blue.background = null
                iv_edit_text_green.background = null
                iv_edit_text_black.background = null
                dialogueActor?.textColor = "#f8e71c"
            }
            iv_edit_text_blue.setOnClickListener {
                iv_edit_text_red.background = null
                iv_edit_text_yellow.background = null
                iv_edit_text_blue.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
                iv_edit_text_green.background = null
                iv_edit_text_black.background = null
                dialogueActor?.textColor = "#4a90e2"
            }
            iv_edit_text_green.setOnClickListener {
                iv_edit_text_red.background = null
                iv_edit_text_yellow.background = null
                iv_edit_text_blue.background = null
                iv_edit_text_green.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
                iv_edit_text_black.background = null
                dialogueActor?.textColor = "#417505"
            }
            iv_edit_text_black.setOnClickListener {
                iv_edit_text_red.background = null
                iv_edit_text_yellow.background = null
                iv_edit_text_blue.background = null
                iv_edit_text_green.background = null
                iv_edit_text_black.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
                dialogueActor?.textColor = "#000000"
            }
            btn_edit_dialog_align_left.setOnClickListener {
                btn_edit_dialog_align_left.setImageResource(R.drawable.ic_alignleft_w)
                btn_edit_dialog_align_center.setImageResource(R.drawable.ic_aligncenter)
                btn_edit_dialog_align_right.setImageResource(R.drawable.ic_alignright)
                dialogueActor?.textAlign = Paint.Align.LEFT
            }
            btn_edit_dialog_align_center.setOnClickListener {
                btn_edit_dialog_align_left.setImageResource(R.drawable.ic_alignleft)
                btn_edit_dialog_align_center.setImageResource(R.drawable.ic_aligncenter_w)
                btn_edit_dialog_align_right.setImageResource(R.drawable.ic_alignright)
                dialogueActor?.textAlign = Paint.Align.CENTER
            }
            btn_edit_dialog_align_right.setOnClickListener {
                btn_edit_dialog_align_left.setImageResource(R.drawable.ic_alignleft)
                btn_edit_dialog_align_center.setImageResource(R.drawable.ic_aligncenter)
                btn_edit_dialog_align_right.setImageResource(R.drawable.ic_alignright_w)
                dialogueActor?.textAlign = Paint.Align.RIGHT
            }
        }
    }

    override fun onDismiss(dialog: DialogInterface?) {
        super.onDismiss(dialog)
        onSetDialogFinish?.onEditTextDialogDismiss()
    }

    fun setDialogue(dialogue: Actor){
        this.dialogueActor = dialogue
    }

    fun setCallBack(onSetDialogFinish: OnSetDialogFinish){
        this.onSetDialogFinish = onSetDialogFinish
    }
    interface OnSetDialogFinish{
        fun onSetDialogText(dialogue: Actor, text: String)
        fun onEditTextDialogDismiss()
    }
}