package com.bomostory.sceneeditmodule.basicdata

import android.content.ContentResolver
import android.provider.MediaStore
import java.io.File

object DataParser {

     fun parseMusic(contentResolver: ContentResolver, paths: ArrayList<String?>): ArrayList<Music>{
        val selection = MediaStore.Audio.Media.IS_MUSIC + " != 0"
        val projection = arrayOf(
                MediaStore.Audio.Media.TITLE,
                MediaStore.Audio.Media.DATA,
                MediaStore.Audio.Media.DURATION
        )
        val cursor = contentResolver.query(
                MediaStore.Audio.Media.EXTERNAL_CONTENT_URI,
                projection,
                selection,
                null, null
        )

        val musics = ArrayList<Music>()
        while (cursor.moveToNext()) {
            val music = Music()
            music.name = cursor.getString(0)
            music.path = cursor.getString(1)
            music.duration = cursor.getString(2).toLong()
            music.endTime = cursor.getString(2).toLong()
            val file = File(music.path)
            if (!paths.contains(file.path)) {
                musics.add(music)
            }
        }
        return musics
    }
}