package com.bomostory.sceneeditmodule.cover

import android.content.Context
import android.util.AttributeSet
import android.view.View
import com.example.tfat.myapplication.R
import kotlinx.android.synthetic.main.view_back_cover_editor.view.*

class BackCoverEditorView @JvmOverloads constructor(
        context: Context,
        attrs: AttributeSet? = null,
        defStyleAttr: Int = 0
) : BaseCoverEditorView(context, attrs, defStyleAttr) {

    var onCancel: View.OnClickListener? = null
    var onSave: View.OnClickListener? = null
    var selectedColor: CoverColor
        get() {
            return coverColorSelectorView_backCoverEditor.selectedColor
        }
        set(value) {
            coverColorSelectorView_backCoverEditor.selectedColor = value
        }


    init {
        View.inflate(context, R.layout.view_back_cover_editor, this)
        coverColorSelectorView_backCoverEditor.apply {
            onChangeListener = object : CoverColorSelectorView.OnChangeListener {
                override fun onChange() {
                    setCoverColor(selectedColor, this@BackCoverEditorView.iv_backCoverEditor_cover)
                }
            }
        }
        btn_backCoverEditor_save.setOnClickListener { onSave?.onClick(it) }
        btn_backCoverEditor_cancel.setOnClickListener { onCancel?.onClick(it) }
    }
}