package com.bomostory.sceneeditmodule.cover

import android.content.Context
import android.graphics.drawable.ColorDrawable
import android.support.constraint.ConstraintLayout
import android.util.AttributeSet
import android.widget.ImageView

abstract open class BaseCoverEditorView @JvmOverloads constructor(
        context: Context,
        attrs: AttributeSet? = null,
        defStyleAttr: Int = 0
) : ConstraintLayout(context, attrs, defStyleAttr) {

    protected fun setCoverColor(coverColor: CoverColor, cover: ImageView) {
        val colorInt = coverColor.getColor(context)
        val colorDrawable = ColorDrawable(colorInt)
        cover.setImageDrawable(colorDrawable)
    }
}
