package com.example.tfat.myapplication.navigationbar

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.widget.ImageButton
import android.widget.RelativeLayout
import com.example.tfat.myapplication.R
import kotlinx.android.synthetic.main.navigation_bar_view.view.*

class NavigationBarView : RelativeLayout{
    private lateinit var scene : RelativeLayout
    private lateinit var actor : RelativeLayout
    private lateinit var brush : RelativeLayout
    private lateinit var dialogue : RelativeLayout

    constructor(context : Context) : super(context) {
        initView()
    }

    constructor(context: Context, attrs: AttributeSet): super(context, attrs) {
        initView()
    }

    constructor(context: Context, attrs: AttributeSet, defStyle: Int): super(context, attrs, defStyle) {
        initView()
    }

    private fun initView(){
        val inflater = LayoutInflater.from(context)
        var rootView = inflater.inflate(R.layout.navigation_bar_view, this, true)
        scene = rootView.findViewById(R.id.scene)
        actor = rootView.findViewById(R.id.actor)
        brush = rootView.findViewById(R.id.brush)
        dialogue = rootView.findViewById(R.id.dialogue)
    }

    fun setonClickSceneBtn(onClickListener: OnClickListener) {
        scene.setOnClickListener(onClickListener)
    }

    fun setonClickActorBtn(onClickListener: OnClickListener) {
        actor.setOnClickListener(onClickListener)
    }

    fun setonClickBrushBtn(onClickListener: OnClickListener) {
        brush.setOnClickListener(onClickListener)
    }

    fun setonClickDialogueBtn(onClickListener: OnClickListener) {
        dialogue.setOnClickListener(onClickListener)
    }

    fun setonClickSettingBtn(onClickListener: OnClickListener) {
        settings.setOnClickListener(onClickListener)
    }

    fun setonClickImageBtn(onClickListener: OnClickListener) {
        layout_navigation_bar_image.setOnClickListener(onClickListener)
    }
}