package com.bomostory.sceneeditmodule.navigationbar.dialogue

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.example.tfat.myapplication.R
import kotlinx.android.synthetic.main.item_actor.view.*

class DialogueAdapter(var data: ArrayList<Int>, var onTouchListeners: ArrayList<View.OnTouchListener>): RecyclerView.Adapter<DialogueAdapter.ViewHolder>() {


    override fun getItemCount(): Int {
        return data.size
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(data?.get(position), onTouchListeners[position])
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): DialogueAdapter.ViewHolder {
        val v1 = LayoutInflater.from(parent.context).inflate(R.layout.dialogue_item, parent, false)
        return ViewHolder(v1)
    }

    class ViewHolder (view : View) : RecyclerView.ViewHolder(view) {
        fun bind(dialogueResource: Int, onTouchListener: View.OnTouchListener) {
            itemView.actor_image.setImageResource(dialogueResource)
            itemView.actor_image.setOnTouchListener(onTouchListener)
        }
    }
}