package com.bomostory.sceneeditmodule.navigationbar.dialogue

import android.content.ClipData
import android.content.ClipDescription
import android.content.Context
import android.support.v7.widget.LinearLayoutManager
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.MotionEvent
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import com.example.tfat.myapplication.R
import kotlinx.android.synthetic.main.dialogue_select_view.view.*

class DialogueView: LinearLayout{
    constructor(context : Context) : super(context) {
        initView()
    }

    constructor(context: Context, attrs: AttributeSet): super(context, attrs) {
        initView()
    }

    constructor(context: Context, attrs: AttributeSet, defStyle: Int): super(context, attrs, defStyle) {
        initView()
    }

    private var dialogueData = ArrayList<Int>()
    private var dialogueListeners = ArrayList<View.OnTouchListener>()
    private var dialogueAdapter = DialogueAdapter(dialogueData, dialogueListeners)

    private fun initView(){
        val inflater = LayoutInflater.from(context)
        inflater.inflate(R.layout.dialogue_select_view, this, true)
        rv_dialogue_view.apply {
            adapter = dialogueAdapter
            layoutManager = LinearLayoutManager(context).apply {
                orientation = LinearLayoutManager.HORIZONTAL
            }
        }
        this.dialogueData.apply {
            clear()
            add(R.drawable.ic_speechbubble_w1)
            add(R.drawable.ic_speechbubble_w2)
            add(R.drawable.ic_speechbubble_w3)
            add(R.drawable.ic_speechbubble_w4)
            add(R.drawable.ic_speechbubble_w5)
            add(R.drawable.ic_speechbubble_w6)
            add(R.drawable.ic_speechbubble_w7)

        }
        this.dialogueListeners.apply {
            clear()
            for (i in 0 until dialogueData.size){
                add(boMoOnTouchListener(dialogueData[i]))
            }
        }
        setDialogueWhite()
        dialogueAdapter.notifyDataSetChanged()
        iv_dialogue_view_white.setOnClickListener {
            this.dialogueData.apply {
                clear()
                add(R.drawable.ic_speechbubble_w1)
                add(R.drawable.ic_speechbubble_w2)
                add(R.drawable.ic_speechbubble_w3)
                add(R.drawable.ic_speechbubble_w4)
                add(R.drawable.ic_speechbubble_w5)
                add(R.drawable.ic_speechbubble_w6)
                add(R.drawable.ic_speechbubble_w7)

            }
            this.dialogueListeners.apply {
                clear()
                for (i in 0 until dialogueData.size){
                    add(boMoOnTouchListener(dialogueData[i]))
                }
            }
            setDialogueWhite()
            dialogueAdapter.notifyDataSetChanged()
        }
        iv_dialogue_view_blue.setOnClickListener {
            this.dialogueData.apply {
                clear()
                add(R.drawable.ic_speechbubble_b1)
                add(R.drawable.ic_speechbubble_b2)
                add(R.drawable.ic_speechbubble_b3)
                add(R.drawable.ic_speechbubble_b4)
                add(R.drawable.ic_speechbubble_b5)
                add(R.drawable.ic_speechbubble_b6)
                add(R.drawable.ic_speechbubble_b7)
            }
            this.dialogueListeners.apply {
                clear()
                for (i in 0 until dialogueData.size){
                    add(boMoOnTouchListener(dialogueData[i]))
                }
            }
            setDialogueBlue()
            dialogueAdapter.notifyDataSetChanged()
        }
        iv_dialogue_view_yellow.setOnClickListener {
            this.dialogueData.apply {
                clear()
                add(R.drawable.ic_speechbubble_y1)
                add(R.drawable.ic_speechbubble_y2)
                add(R.drawable.ic_speechbubble_y3)
                add(R.drawable.ic_speechbubble_y4)
                add(R.drawable.ic_speechbubble_y5)
                add(R.drawable.ic_speechbubble_y6)
                add(R.drawable.ic_speechbubble_y7)
            }
            this.dialogueListeners.apply {
                clear()
                for (i in 0 until dialogueData.size){
                    add(boMoOnTouchListener(dialogueData[i]))
                }
            }
            setDialogueYellow()
            dialogueAdapter.notifyDataSetChanged()
        }
        iv_dialogue_view_green.setOnClickListener {
            this.dialogueData.apply {
                clear()
                add(R.drawable.ic_speechbubble_g1)
                add(R.drawable.ic_speechbubble_g2)
                add(R.drawable.ic_speechbubble_g3)
                add(R.drawable.ic_speechbubble_g4)
                add(R.drawable.ic_speechbubble_g5)
                add(R.drawable.ic_speechbubble_g6)
                add(R.drawable.ic_speechbubble_g7)
            }
            this.dialogueListeners.apply {
                clear()
                for (i in 0 until dialogueData.size){
                    add(boMoOnTouchListener(dialogueData[i]))
                }
            }
            setDialogueGreen()
            dialogueAdapter.notifyDataSetChanged()
        }
        iv_dialogue_view_orange.setOnClickListener {
            this.dialogueData.apply {
                clear()
                add(R.drawable.ic_speechbubble_r1)
                add(R.drawable.ic_speechbubble_r2)
                add(R.drawable.ic_speechbubble_r3)
                add(R.drawable.ic_speechbubble_r4)
                add(R.drawable.ic_speechbubble_r5)
                add(R.drawable.ic_speechbubble_r6)
                add(R.drawable.ic_speechbubble_r7)
            }
            this.dialogueListeners.apply {
                clear()
                for (i in 0 until dialogueData.size){
                    add(boMoOnTouchListener(dialogueData[i]))
                }
            }
            setDialogueOrange()
            dialogueAdapter.notifyDataSetChanged()
        }
    }

    private fun setDialogueWhite(){
        iv_dialogue_view_white.setImageResource(R.drawable.ic_done)
        iv_dialogue_view_blue.setImageDrawable(null)
        iv_dialogue_view_yellow.setImageDrawable(null)
        iv_dialogue_view_green.setImageDrawable(null)
        iv_dialogue_view_orange.setImageDrawable(null)
    }

    private fun setDialogueBlue(){
        iv_dialogue_view_white.setImageDrawable(null)
        iv_dialogue_view_blue.setImageResource(R.drawable.ic_done)
        iv_dialogue_view_yellow.setImageDrawable(null)
        iv_dialogue_view_green.setImageDrawable(null)
        iv_dialogue_view_orange.setImageDrawable(null)
    }

    private fun setDialogueYellow(){
        iv_dialogue_view_white.setImageDrawable(null)
        iv_dialogue_view_blue.setImageDrawable(null)
        iv_dialogue_view_yellow.setImageResource(R.drawable.ic_done)
        iv_dialogue_view_green.setImageDrawable(null)
        iv_dialogue_view_orange.setImageDrawable(null)
    }

    private fun setDialogueGreen(){
        iv_dialogue_view_white.setImageDrawable(null)
        iv_dialogue_view_blue.setImageDrawable(null)
        iv_dialogue_view_yellow.setImageDrawable(null)
        iv_dialogue_view_green.setImageResource(R.drawable.ic_done)
        iv_dialogue_view_orange.setImageDrawable(null)
    }
    private fun setDialogueOrange(){
        iv_dialogue_view_white.setImageDrawable(null)
        iv_dialogue_view_blue.setImageDrawable(null)
        iv_dialogue_view_yellow.setImageDrawable(null)
        iv_dialogue_view_green.setImageDrawable(null)
        iv_dialogue_view_orange.setImageResource(R.drawable.ic_done)
    }

    private fun boMoOnTouchListener(resource: Int) : View.OnTouchListener {
        return View.OnTouchListener { view, motionEvent ->
            when (motionEvent.action) {
                MotionEvent.ACTION_DOWN -> {
                    val item = ClipData.Item(resource.toString())
                    val mimeTypes = arrayOf(ClipDescription.MIMETYPE_TEXT_PLAIN)
                    val dragData = ClipData(null, mimeTypes, item)
                    val shadow = View.DragShadowBuilder(view.findViewById<ImageView>(R.id.actor_image))
                    view.findViewById<ImageView>(R.id.actor_image).startDrag(dragData, shadow, null, View.DRAG_FLAG_GLOBAL)
                }
            }
            return@OnTouchListener true
        }
    }
}