package com.bomostory.sceneeditmodule.screen.view

import android.content.Context
import android.graphics.*
import android.graphics.drawable.Drawable
import android.util.AttributeSet
import android.widget.ImageView
import com.bomostory.sceneeditmodule.DialogueDrawer
import com.bomostory.sceneeditmodule.basicdata.Actor

class ActorView : ImageView {

    var data: Actor? = null
        set(value) {
            field = value
            value?.let {
                if(!it.isDialogue) setImageDrawable(Drawable.createFromPath(it.resourcePath))
                if (it.isMirror && !it.isDialogue) {
                    this.scaleX = -1f
                    this.scaleY = 1f
                }
                this.alpha = it.opacity
            }
        }
    constructor(context: Context) : super(context)

    constructor(context: Context, attrs: AttributeSet) : super(context, attrs)

    constructor(context: Context, attrs: AttributeSet, defStyle: Int) : super(context, attrs, defStyle)

    override fun onDraw(canvas: Canvas?) {
        super.onDraw(canvas)
        data?.let {
            if (it.isDialogue) {
                canvas?.drawBitmap(DialogueDrawer.drawDialogue(context, it), 0f, 0f, null)
            }
        }
    }
}