package com.bomostory.sceneeditmodule.utils

import android.app.AlertDialog
import android.content.Context
import android.content.Intent
import android.support.v4.content.FileProvider
import android.widget.Toast
import com.example.tfat.myapplication.R
import java.io.File

object Utils {
    fun showExportPdfCompleteThenViewDialog(context: Context, authority: String, file: File) {
        AlertDialog.Builder(context)
                .setMessage(R.string.export_pdf_complete_dialog_msg)
                .setPositiveButton(R.string.export_pdf_complete_dialog_positive) { _, _ ->
                    val uri = FileProvider.getUriForFile(context, authority, file)
                    val intent = Intent(Intent.ACTION_VIEW, uri).apply {
                        addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
                        addFlags(Intent.FLAG_ACTIVITY_NO_HISTORY)
                        addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
                        setDataAndType(uri, "application/pdf")
                    }
                    if (intent.resolveActivity(context.packageManager) != null) {
                        Intent.createChooser(intent, "").apply {
                            context.startActivity(this)
                        }
                    } else {
                        Toast.makeText(context, R.string.share_pdf_failed_no_app, Toast.LENGTH_SHORT).show()
                    }
                }.show()
    }
}